#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <avr/signal.h>
#include <stdio.h>
#include <avr/wdt.h>
#include <avr/delay.h>
#include <avr/eeprom.h>

#ifndef EEMEM
// alle Textstellen EEMEM im Quellcode durch __attribute__ ... ersetzen
#define EEMEM  __attribute__ ((section (".eeprom")))
#endif


#define BUTTON_O    4   				// Wenn Center gedrckt wird, wird PortB Pin4 gesetzt

#define PINB_MASK (1<<PINB4)

#define FOSC 8000000UL					// Taktfrequenz in Hz
#define BAUD 38400UL					// Baud-Rate in Bits pro Sekunde
#define UBRR_VAL FOSC/16/BAUD-1			// Berechnung des Wertes fr das Register UBBR (16Bit-Register)

#define DELAY FOSC/1000/1024			// Umrechnungswert fr Delayfunktion


void initializer(void);
void USARTinit(void);
char isCharAvailable(void);
char receiveChar(void);
void sendChar(char ) ;
void sendString(char *);
void programmInit(void);
void programmStart(void);
void statusSenden(void);
void parseInput(char *);
void PinChangeInterrupt(void);
void stdError(void);
void syncError(void);
void ausfError(void);
void zeitError(void);
void testError(void);
void wdError(void);
void doTest(void);
void doSync(void);
void getSync(void);
void eepromWrite(int, int);
void eepromOverwrite(void);
int eepromRead(int);
