#include <avr/wdt.h>
#include <avr/delay.h>
#include <avr/eeprom.h>

#define FOSC 8000000UL					// Taktfrequenz in Hz
#define DelayMS FOSC/4/1000				// DelayMs entspricht 1mS
#define DELAY FOSC/1000/1024

#define RamA 0x0100
#define RamE 0x04FF

extern int iWDSpeicher;					// Speicherzelle in der der Status des WD-Tests festgehalten wird


// Variable definieren
extern int iTestStat;
extern int iTestAnzahl;

// Methode zur Auswahl des Tests deklarieren
void selectTest(void);
void startTest(int);
void initTest(void);

// Sonstige
void eepromWriteTo(int, int);

// Registertests
extern void TEST_R0(void);
extern void TEST_R1(void);
extern void TEST_R2(void);
extern void TEST_R3(void);
extern void TEST_R4(void);
extern void TEST_R5(void);
extern void TEST_R6(void);
extern void TEST_R7(void);
extern void TEST_R8(void);
extern void TEST_R9(void);
extern void TEST_R10(void);
extern void TEST_R11(void);
extern void TEST_R12(void);
extern void TEST_R13(void);
extern void TEST_R14(void);
extern void TEST_R15(void);
extern void TEST_R16(void);
extern void TEST_R17(void);
extern void TEST_R18(void);
extern void TEST_R19(void);
extern void TEST_R20(void);
extern void TEST_R21(void);
extern void TEST_R22(void);
extern void TEST_R23(void);
extern void TEST_R24(void);
extern void TEST_R25(void);
extern void TEST_R26(void);
extern void TEST_R27(void);
extern void TEST_R28(void);
extern void TEST_R29(void);
extern void TEST_R30(void);
extern void TEST_R31(void);


// Push-Pop-Ret-Test
extern void PPRJ_TEST(void);

// Arithmetische Tests
extern void ADD_TEST(void);
extern void ADDC_TEST(void);
extern void SUB_TEST(void);
extern void INC_TEST(void);
extern void DEC_TEST(void);
extern void MUL_TEST(void);

// Tests der logischen Bitoperationen
extern void CLR_TEST(void);
extern void COM_TEST(void);
extern void LSL_TEST(void);
extern void LSR_TEST(void);
extern void ROL_TEST(void);
extern void ROR_TEST(void);
extern void SWAP_TEST(void);

// Tests der logischen Operationen
extern void AND_TEST(void);
extern void OR_TEST(void);
extern void EOR_TEST(void);

// Tests der Transfer-Befehle
extern void mov_test(void);
extern void movw_test(void);
extern void ldi_test(void);
extern void ld_test(void);

// Port-Tests
void PortTest(void);

// Timer-Tests
void Timer0Test(void);
void Timer1Test(void);
void Timer2Test(void);

// Watchdog-Test
void WDTest(void);

// RAM-Test
void Ram_Test(void);
void Ram_Check(int,int);