#include <avr/io.h>

; Einstiegspunkte fr den Compiler deklarieren
.global CLR_TEST
.global COM_TEST
.global LSL_TEST
.global LSR_TEST
.global ROL_TEST
.global ROR_TEST
.global SWAP_TEST

; ********************* CLR_TEST ******************************************
CLR_TEST:	PUSH	R31					; alte Registerwerte speichern
			LDI    	R31, 0xFF			; Testmuster 1 laden
			CLR     R31                 ; Befehlstest 
			CPI		R31, 0x00			; Vergleich mit Erwartungshaltung
			BRNE	CLR_err				; in Fehlerroutine springen, falls Vergleich != Erwartung
			POP		R31					; alte Registerwerte wieder herstellen
			RET
CLR_err:    CALL 	testError			; Springe in Routine der Fehlermeldung



; ********************* COM_TEST ******************************************
COM_TEST:	PUSH	R31					; alte Registerwerte speichern
			LDI     R31, 0xAA			; Testmuster 1 laden
			COM     R31                 ; Befehlstest 
			CPI		R31, 0x55			; Vergleich mit Erwartungshaltung
			BRNE	COM_err				; in Fehlerroutine springen, falls Vergleich != Erwartung
			POP		R31					; alte Registerwerte wieder herstellen
			RET
COM_err:   	CALL 	testError			; Springe in Routine der Fehlermeldung



; ********************* LSL_TEST *******************************************
LSL_TEST:	PUSH	R31					; alte Registerwerte speichern
			LDI		R31, 0xAA           ; Testmuster 1 laden
			LSL		R31					; Befehlstest 
			CPI		R31, 0x54			; Vergleich mit Erwartungshaltung
			BRNE	LSL_err				; in Fehlerroutine springen, falls Vergleich != Erwartung
			POP		R31					; alte Registerwerte wieder herstellen
			RET
LSL_err:	CALL 	testError			; Springe in Routine der Fehlermeldung


; ********************* LSR_TEST *******************************************
LSR_TEST:	PUSH	R31					; alte Registerwerte speichern
			LDI		R31, 0x55           ; Testmuster 1 laden
			LSR		R31					; Befehlstest 
			CPI		R31, 0x2A			; Vergleich mit Erwartungshaltung
			BRNE	LSR_err				; in Fehlerroutine springen, falls Vergleich != Erwartung
			POP		R31					; alte Registerwerte wieder herstellen
			RET
LSR_err:	CALL 	testError			; Springe in Routine der Fehlermeldung 


; ********************* ROL_TEST ******************************************

ROL_TEST:	PUSH	R31					; alte Registerwerte speichern
			LDI		R31, 0xAA			; Testmuster 1 laden
			ROL		R31					; Befehlstest 
			ROL		R31					
			CPI		R31, 0xA9			; Vergleich mit Erwartungshaltung
			BRNE	ROL_err				; in Fehlerroutine springen, falls Vergleich != Erwartung
			POP		R31					; alte Registerwerte wieder herstellen
			RET
ROL_err:	CALL 	testError			; Springe in Routine der Fehlermeldung


; ********************* ROR_TEST ******************************************

ROR_TEST:	PUSH	R31					; alte Registerwerte speichern
			LDI		R31, 0x55			; Testmuster 1 laden
			ROR		R31					; Befehlstest 
			ROR		R31
			CPI		R31, 0x95			; Vergleich mit Erwartungshaltung
			BRNE	ROR_err				; in Fehlerroutine springen, falls Vergleich != Erwartung
			POP		R31					; alte Registerwerte wieder herstellen
			RET
ROR_err:	CALL 	testError			; Springe in Routine der Fehlermeldung


; ********************* SWAP_TEST *****************************************
SWAP_TEST:	PUSH	R31					; alte Registerwerte speichern
			LDI		R31, 0xC3			; Testmuster 1 laden
			SWAP	R31					; Befehlstest
			CPI		R31, 0x3C			; Vergleich mit Erwartungshaltung 
			BRNE	SWAP_err			; in Fehlerroutine springen, falls Vergleich != Erwartung
			POP		R31					; alte Registerwerte wieder herstellen
			RET 
SWAP_err:   CALL 	testError			; Springe in Routine der Fehlermeldung
