#include <avr/io.h>

.global PPRJ_TEST

;Beginn des Tests	
PPRJ_TEST:		PUSH	R16						;Speichert die Werte der Register auf dem Stack
				PUSH	R26
				PUSH	R27
				PUSH	R28
				PUSH	R29
				PUSH	R30
				PUSH	R31

;Inkrementstest, wird der Stackpointer korrekt dekrementiert?									
PPR_PUSHPOP:	IN		R26, _SFR_IO_ADDR(SPL)	;StackPointer in Register X & Y schreiben			
				IN		R27, _SFR_IO_ADDR(SPH)
				IN		R28, _SFR_IO_ADDR(SPL)			
				IN		R29, _SFR_IO_ADDR(SPH)					
				LDI		R16, 0xAA				;0xAA auf den Stack pushen (dabei wird SP dekrementiert)
				PUSH	R16								
				LD		R16, -Y 				;Anpassen des erwarteten Wertes.
				IN		R16, _SFR_IO_ADDR(SPL) 	;aktuellen SP-Wert in Vergleichsvariablen schreiben
				IN		R17, _SFR_IO_ADDR(SPH)	
				CP		R28, R16				;Vergleich des aktuellen Stackpointers mit dem vorgesehenen Stackpointers	
				BRNE	PPR_err1	
				CP		R29, R17	
				BRNE	PPR_err1			

;Es wird getestet ob der Wert auf dem Stack auch dem erwarteten Wert entspricht
;Test ob Push einwandfrei funktioniert
				CLR		R31		
				IN		R28, _SFR_IO_ADDR(SPL)	;Stackpointer in Register Y schreiben	
				IN		R29, _SFR_IO_ADDR(SPH)			
				LD		R31, Y+					;Anpassen des erwarteten Wertes
				LD		R31, Y
				CPI		R31, 0xAA				;Vergleich		
				BRNE	PPR_err1			

;Nun wird geschaut ob auch der POP-Befehl wie erwartet funktioniert
				CLR		R31					
				POP		R31						;Wert vom Stack holen
				CPI		R31, 0xAA				;Vergleich mit Erwartung
				BRNE	PPR_err1			

;berprfung ob Stackpointer inkrementiert wird	wenn ein POP durchgefhrt wurde
				IN		R30, _SFR_IO_ADDR(SPL) 	;aktuellen Stackpointerwert holen
				IN		R31, _SFR_IO_ADDR(SPH)
				CP		R30, R26				;Vergleichen der Werte
				BRNE	PPR_err1			
				CP		R31, R27			
				BRNE	PPR_err1
				
;RET-Test, Testet ob der Return-Befehl einwandfrei funktioniert
PPR_RET:		LDI 	ZH, hi8(pm(PPR_RET1))	;Holen der Adresse zu PPR_RET1
				LDI 	ZL, lo8(pm(PPR_RET1))	
				PUSH 	ZL				 		;Pushen der Adresse auf den Stack	 
				PUSH 	ZH					
				RET								;Sprung zu PPR_RET1
				NOP							
				NOP							
				NOP							
				JMP		PPR_err1			

PPR_RET1:		JMP		PPR_ENDE				;Sprung zu PPR_Ende, testet die JMP-Funktion
				NOP							
				NOP							 
				NOP							
				NOP							
				NOP							
PPR_err1:		CALL 	testError				;Springe in Routine der Fehlermeldung				
				
PPR_ENDE:		POP		R31						;Schreibt die zuvor gespeicherte Werte in die Register zurck
				POP		R30
				POP		R29
				POP		R28
				POP		R27
				POP		R26
				POP		R16
				RET
